
import fr.cnam.provider.*;

// Creation du consommateur (classe applicative)
public class Consommateur implements Consumer
{
  private ConsumerImpl consumer;

  public Consommateur(String ident,int canal)throws Exception{
    this.ident=ident;
    consumer = new ConsumerImpl(canal);

    // Pour que le producteur  puisse posser une information au Consommateur Applicatif
    consumer.setConsumer(this);
  }

  private static int compteur=0;
  private String ident;

  // Algorithme qui tire toute les secondes un objet aux producteurs
  //
  public void tirer(){
    try{
      while(true){
        System.out.println(ident+"> "+"PULL : "+consumer.pull());
        try{Thread.sleep(1000);}catch(Exception ex){};
      }
    } catch(Exception ex){};
  }

  // Traitement traitement sur recepetion d'un objet
  //
  public void push(Object obj)
  {
    compteur++;
    System.out.println(ident+"> "+"PUSH  : "+obj);
    // TEST (pour tester que la communication est bien asynchrone
    // if ( (ident.equals("CONSO1")) && (compteur%5==0))try{Thread.sleep(10000);}catch(Exception ex){};
  }


  // ================================================================
  // args[0] : numro du canal sur lequel le Consommateur Applicatif veut tirer une information
  // args[1] : Identification du consommateur
  //
  public static void main(String... args) throws Exception
  {
    // Creation d'un consommateur
    Consommateur consommateur = new Consommateur(args[1],Integer.parseInt(args[0]));

    // Pour tirer rgulirement un objet sur le producteur
    //
    consommateur.tirer();
  }

}